.initAffyBatchEnvPtr <- function(where) {

  ## This is a hack...
  ## but 'pass-by-value' hurts us too much for large (but common)
  ## instances of this class 
  ##   -- LG

  ## "exprSetEnvPtr" could benefit to others... could be moved
  ## to Biobase after approval by the higher instances


  ## moved to Biobase
#   if( !isGeneric("exprs<-") )
#     setGeneric("exprs<-", function(object, value)
#                standardGeneric("exprs<-"), where=where)
  
#   setReplaceMethod("exprs", signature="exprSet",
#                    function(object, value) {
#                      object@exprs <- value
#                      return(object)  
#                    },
#                    where = where)

  if( !isGeneric("se.exprs<-") )
    setGeneric("se.exprs<-", function(object, value)
               standardGeneric("se.exprs<-"), where=where)

  setReplaceMethod("se.exprs", signature="exprSet",
                   function(object, value) {
                     object@se.exprs <- value
                     return(object)
                   },
                   where = where)

  
  setClass("exprSetEnvPtr.abstract",
           representation(envptr = "environment"),
           where = where)
  
  ## override original accessor / replace method for exprs
  setMethod("exprs", "exprSetEnvPtr.abstract",
            function(object) get("exprs", envir=object@envptr),
            where=where)
  setReplaceMethod("exprs", "exprSetEnvPtr.abstract",
                   function(object, value) {
                     assign("exprs", value, envir=object@envptr)
                     return(object)
                     },
                   where=where)
  
  ## override original accessor / replace method for se.exprs
  setMethod("se.exprs", "exprSetEnvPtr.abstract",
            function(object) get("se.exprs", envir=object@envptr),
            where=where)
  setReplaceMethod("se.exprs", "exprSetEnvPtr.abstract",
                   function(object, value) {
                     assign("se.exprs", value, envir=object@envptr)
                     return(object)
                   },
                   where=where)
  
  ## override original accessor / replace method for exprs
  setMethod("description", "exprSetEnvPtr.abstract",
            function(object) get("description", envir=object@envptr),
            where=where)
  setReplaceMethod("description", "exprSetEnvPtr.abstract",
                   function(object, value) {
                     assign("description", value, envir=object@envptr)
                     return(object)
                     },
                   where=where)

  setClass("exprSetEnvPtr",
           contains=c("exprSetEnvPtr.abstract", "exprSet"),
           where = where)

  ## constructor for the class (set the original slot exprs in exprSet
  ## to a mininal (zero) size.
  setMethod("initialize", "exprSetEnvPtr",
            function(.Object, exprs=matrix(), se.exprs=matrix(), phenoData=new("phenoData"), description=new("MIAME"), annotation="", notes="", envptr=new.env()) {
               .Object@envptr <- envptr
               assign("exprs", exprs, envir=.Object@envptr)
               .Object@exprs <- matrix(0, nr=0, nc=0)
               assign("se.exprs", se.exprs, envir=.Object@envptr)
               exprs <- matrix()
               .Object@se.exprs <- matrix(0, nr=0, nc=0)
               assign("description", description, envir=.Object@envptr)
               se.exprs <- matrix()
               
               callNextMethod(.Object)
               return(.Object)
              },
            where=where) 

  
  setClass("AffyBatchEnvPtr",
           contains=c("exprSetEnvPtr.abstract", "AffyBatch"),
           where = where)
  
  ## a bit of acrobatics, now... let's hijiack the methods from AffyBatch...
  ## (consistency with AffyBatch is checked in the end. FIXME: not done yet
  ## more elegant alternatives are welcome...)
  ## (side note: I would be very happy for some of the methods to disappear...
  ## like "pm", "mm", "pmindex", "mmindex"...
  setMethod("nrow", signature("AffyBatchEnvPtr"),
            function(x) get("nrow", envir=x@envptr),
            where = where)
  setMethod("ncol", signature("AffyBatchEnvPtr"),
            function(x) get("ncol", envir=x@envptr),
            where = where)
  
  setReplaceMethod("intensity", signature("AffyBatchEnvPtr"),
                   function(object, value) {
                     if (! is.matrix(value))
                       error("invalid assignment. Should be a matrix")
                     if (nrow(value) != nrow(object) * ncol(object))
                       error("matrix dim mistmatch")
                     exprs(object) <- value
                     return(object)
                   },
                   where = where)

  setMethod("initialize", signature("AffyBatchEnvPtr"),
            function(.Object, exprs=matrix(), cdfName=character(0), phenoData=new("phenoData"),
                     nrow=NaN, ncol=NaN, annotation="", description="", notes="", envptr=new.env()) {
              .Object@envptr <- envptr
              assign("nrow", nrow, envir=.Object@envptr)
              nrow <- NaN
              assign("ncol", ncol, envir=.Object@envptr)
              ncol <- NaN
              .Object@cdfName <- cdfName
              cdfName <- NA
              
              callNextMethod(.Object)
              return(.Object)
            }, where=where)
  
}
