\name{AffyBatchEnvPtr-class}
\docType{class}
\alias{AffyBatchEnvPtr-class}
\title{Class "AffyBatchEnvPtr"}
\description{ A class for which, for a given instance, some of the
  attributes are common to all the copies of
  the instance (i.e. never really copied).}
\section{Objects from the Class}{
Objects can be created by calls of the form \code{new("AffyBatchEnvPtr", exprs, cdfName, phenoData, nrow, ncol, annotation, description, notes, envptr)}.
Defaults exist for missing arguments.
}
\section{Slots}{
  \describe{
    \item{\code{cdfName}:}{Object of class \code{"character", from class "AffyBatch"} ~~ }
    \item{\code{nrow}:}{`pointed' {Object of class \code{"numeric", from class "AffyBatch"} }}
    \item{\code{ncol}:}{`pointed' Object of class \code{"numeric", from class "AffyBatch"} ~~ }
    \item{\code{exprs}:}{`pointed' Object of class \code{"matrix", from class "AffyBatch"} ~~ }
    \item{\code{se.exprs}:}{`pointed' Object of class \code{"matrix", from class "AffyBatch"} ~~ }
    \item{\code{phenoData}:}{Object of class \code{"phenoData", from class "AffyBatch"} ~~ }
    \item{\code{description}:}{`pointed' Object of class \code{"characterORMIAME", from class "AffyBatch"} ~~ }
    \item{\code{annotation}:}{Object of class \code{"character", from class "AffyBatch"} ~~ }
    \item{\code{notes}:}{Object of class \code{"character", from class "AffyBatch"} ~~ }
    \item{\code{envptr}:}{Object of class \code{"environment",
	from class "exprSetEnvPtr.abstract"}. The `pointed' slot values
      are stored in this environment (see below).}
  }
}
\section{Extends}{
Class \code{"exprSetPtr.abstract"}, directly.
Class \code{"AffyBatch"}, directly.
Class \code{"exprSet"}, by class "AffyBatch".
}
\section{Methods}{
  \describe{
    \item{initialize}{\code{signature(.Object = "AffyBatchEnvPtr")}: A
      constructor (called by \code{new}) }
    \item{intensity<-}{\code{signature(object = "AffyBatchEnvPtr")}: A
      method to replace the value in the `pointed' slot \code{exprs}}
    \item{ncol}{\code{signature(x = "AffyBatchEnvPtr")}: A method to
      access the `pointed' slot \code{ncol} }
    \item{nrow}{\code{signature(x = "AffyBatchEnvPtr")}: A method to
      access the `pointed' slot \code{nrow} }
  }
}
\author{ Laurent }
\note{ The `pointed' slots are not stored where you would expect. They
  are stored in an environment (which can be shared by all the copies of
  an instance). The accessor function retrieve the values from that
  environment. The slot \code{envptr} is a pointer to that
  environment. Using this class lowers the memory usage, as the large
  object do not have to be copied through function calls, but one
  should remain aware that the modifications made on the `pointed' slots
  are effective for all the copies of the instance.
}
\section{Warning }{ The `pointed' slots should only be accessed / replaced by their respective accessor /
  replace functions. DO NOT USE THE \code{@} operator for
  \code{intensity} (or \code{exprs} by inheritance),
  \code{se.exprs} and \code{description}.
  The results are unpredictable if you don't comply to this\ldots
  As you righteously fear it, this is a hack. The access to the
  `pointed' slots must go through the accessors (the fishing of the
  right values from the environment is done there) since the operator
  \code{@} could not be redefined (or I could not figure out how I
  could). This class appears to be handled correctly by the processing
  function \code{\link[affy]{expresso}}, and return an
  \code{\link[Biobase]{exprSet}} (I parsed and processed around 90 U95 chips with
  less than three quarter of a gigabyte).
  
  
}

\seealso{
  \code{\link[affy]{AffyBatch-class}}, \code{\link{exprSetEnvPtr-class}}
}

\examples{
## see example in exprSetEnvPtr-class
}
\keyword{classes}
